function Events() {

};



Event.type = function(id, imageSrc, text, sound, color) {

  this.id = id; //

  this.imageSrc = imageSrc; //

  this.text = text; // text for slider

  this.sound = sound; // text for slider

  this.color = color;

  //LiveFox.Log.info("id:" + this.id + " image:"+this.imageSrc + " text:"+this.text + " sound:"+this.sound+" color:" + this.color);

}



Events.type = {

  GOAL: new Event.type(10, LiveFox.Image.event.goal, "event.goal", LiveFox.Sound.sample.ovation, LiveFox.Notify.color.green),

  PENALTY_GOAL: new Event.type(15, LiveFox.Image.event.penalty_goal, "event.penalty_goal", LiveFox.Sound.sample.ovation, LiveFox.Notify.color.green),

  PENALTY_MISS: new Event.type(16, LiveFox.Image.event.penalty_miss, "event.penalty_miss", LiveFox.Sound.sample.miss, LiveFox.Notify.color.red),

  INJURY: new Event.type(20, LiveFox.Image.event.injury, "event.injury", LiveFox.Sound.sample.boo, LiveFox.Notify.color.red),

  RED: new Event.type(30, LiveFox.Image.event.red, "event.red", LiveFox.Sound.sample.whistle, LiveFox.Notify.color.red),

  YELLOW2: new Event.type(40, LiveFox.Image.event.yellow2, "event.yellow2", LiveFox.Sound.sample.whistle, LiveFox.Notify.color.red),

  BRUISED: new Event.type(50, LiveFox.Image.event.bruised, null, null, LiveFox.Notify.color.orange),

  YELLOW: new Event.type(60, LiveFox.Image.event.yellow, null, LiveFox.Sound.sample.whistle, LiveFox.Notify.color.yellow),

  MISS: new Event.type(70, LiveFox.Image.event.miss, null, LiveFox.Sound.sample.miss, LiveFox.Notify.color.grey),

  SUN: new Event.type(80, LiveFox.Image.event.sun),

  FEW_CLOUDS: new Event.type(90, LiveFox.Image.event.few_clouds),

  OVERCAST: new Event.type(100, LiveFox.Image.event.overcast),

  RAIN: new Event.type(110, LiveFox.Image.event.rain),

  HATTRICK: new Event.type(120, LiveFox.Image.event.hattrick, null, LiveFox.Sound.sample.tarzan),

  INFO: new Event.type(200, LiveFox.Image.event.info),

  NONE: new Event.type(1000, LiveFox.Image.transparent)

};



Event.special = function(txt, img) {

	this.txt = txt;

	this.imgSrc = img;

}



function Event (i, m, sp, st, op, k, t) {

  var zeroLead = function(key) {

    var zeros = ["000", "00", "0", ""];

    var id = key.split("_")[0];

    return zeros[id.length]+id;

  }

  

  var keyId = zeroLead(k);

  

  this.index = i;

  this.minute = m;

  this.subjectPlayerId = sp;

  this.subjectTeamId = st;

  this.objectPlayerId = op;

  this.key = {

    txt: k,

    ABC: keyId,

    A: keyId[0],

    B: keyId[1],

    C: keyId[2],

    AB: keyId[0]+keyId[1],

    BC: keyId[1]+keyId[2]

  }

  this.match = null,

  this.text = t;

  this.type = Events.type.NONE;

	this.special = null;

};



Event.prototype.isInfo = function() {

  return (

    this.type == Events.type.INFO

    || this.type == Events.type.SUN

    || this.type == Events.type.FEW_CLOUDS

    || this.type == Events.type.OVERCAST

    || this.type == Events.type.RAIN

  )

}







/* ----------------------------------------------------------------

 * commun Parse functions

 * ---------------------------------------------------------------- */

Events.ParseList = function(xml) {

  var regStr = "(<Event\\s(?:.*?)</Event>)";

  var regExp;

  var event, index;

  var found;

  var events = new Object();



  try {

    var first=Number.MAX_VALUE, last=0;

    regExp = new RegExp(regStr, "g");

    for(;found = regExp.exec(xml);) {

      event = Events.ParseEvent(found[1]);

      

      first = Math.min(first, event.index);

      last = Math.max(last, event.index);

      

      events["_" + event.index] = event;

    }

    events.first = first;

    events.last = last;

  } catch(e) {

    alert("Event.ParseList() : " + e);

  }

  return events;

}



Events.ParseEvent = function(xml) {

  try {

    return new Event(

      Events.ParseIndex(xml),

      Events.ParseMinute(xml),

      Events.ParseSubjectPlayerId(xml),

      Events.ParseSubjectTeamId(xml),

      Events.ParseObjectPlayerId(xml),

      Events.ParseKey(xml),

      Events.ParseText(xml)

    )

    

  } catch(e) {

    alert("Event.ParseEvent : " + e);

  }

  return null;

}



Events.ParseIndex = function (xml) {

  var indexStr = Util.Parse("<Event \\s*?Index=\"(.*?)\"\\s*?>", xml);

  return parseInt(indexStr, 10);

};



Events.ParseMinute = function (xml) {

  return Util.Parse("<Minute>(.*?)</Minute>", xml);

};



Events.ParseSubjectPlayerId = function (xml) {

  return Util.Parse("<SubjectPlayerID>(.*?)</SubjectPlayerID>", xml);

};



Events.ParseObjectPlayerId = function (xml) {

  return Util.Parse("<ObjectPlayerID>(.*?)</ObjectPlayerID>", xml);

};



Events.ParseSubjectTeamId = function (xml) {

  return Util.Parse("<SubjectTeamID>(.*?)</SubjectTeamID>", xml);

};



Events.ParseKey = function (xml) {

  return Util.Parse("<EventKey>(.*?)</EventKey>", xml);

};



Events.ParseText = function (xml) {

  return Util.Parse("<EventText>(.*?)</EventText>", xml);

};

 





/** --------------------------------------------

  * - translates the type of event.

  * --------------------------------------------

  * - if it is an information event, adds that information to the match

  * - (weather, team formation, etc)

  * - 

  * - otherwise, sets actionEvent flag to true; 

  * --------------------------------------------

  */

Events.translate = function (match, event) {

  var team;

  event.match = match;

  switch (event.key.A) {

    case "0": //match information/statistics

      switch (event.key.BC) {

        case "20": // formation

          event.type=Events.type.INFO;

          match.getSideById(event.subjectTeamId).formation = Events.translate.parseFormation(event.text);

          break;

        case "21": // lineup

          team = match.getTeamById(event.subjectTeamId);

          event.type=Events.type.INFO;

          event.lineupElement = LiveFox.DOM.createLineupElement("ev_"+match.id+"_"+match.youth+"_"+event.index, Events.translate.parseLineup(Util.CleanText(event.text)));

          break;

        case "25": // derby

          event.type=Events.type.INFO;

          break;

        case "26": // neutral ground

          event.type=Events.type.INFO;

          break;

        case "27": // away team plays home

          event.type=Events.type.INFO;

          break;

        case "30": // weather rain

          event.type=Events.type.RAIN;

          match.weather.image = LiveFox.Image.weather.rain;

          match.arena.attendance = event.objectPlayerId;

          break;

        case "31": // heavy clouds

          event.type=Events.type.OVERCAST;

          match.weather.image = LiveFox.Image.weather.overcast;

          match.arena.attendance  = event.objectPlayerId;

          break;

        case "32": // low clouds

          event.type=Events.type.FEW_CLOUDS;

          match.weather.image = LiveFox.Image.weather.few_clouds;

          match.arena.attendance  = event.objectPlayerId;

          break;

        case "33": // sun

          event.type=Events.type.SUN;

          match.weather.image = LiveFox.Image.weather.sun;

          match.arena.attendance  = event.objectPlayerId;

          break;

        case "40": // possession rate

          // subjectTeamId: team id

          // objectPlayerId: rate

          event.type=Events.type.INFO;

          break;

        case "41": // best player

          // subjectPlayerId: player id

          // subjectTeamId: team id

          event.type=Events.type.INFO;

          break;

        case "42": // worst player

          // subjectPlayerId: player id

          // subjectTeamId: team id

          event.type=Events.type.INFO;

          break;

        case "45": // halftime

          event.type=Events.type.INFO;

          break;

        case "46": // hat-trick

          // subjectPlayerId: player id

          // subjectTeamId: team id

          event.type=Events.type.HATTRICK

          break;

        case "47": // ball possession 50-50

          event.type=Events.type.INFO;

          break;

        case "55":

        case "56": // Panalty time: score

          event.type=Events.type.PENALTY_GOAL;

          Events.translate.addScorers(event);

          break;

        case "57": // Panalty time: nervous and scores

          event.type=Events.type.PENALTY_GOAL;

          Events.translate.addScorers(event);

          break;

        case "58": // Panalty time: nervous and miss

          event.type=Events.type.PENALTY_MISS;

          break;

        case "59": // Panalty time: goalkeeper gets ball

          event.type=Events.type.PENALTY_MISS;

          break;

        case "60": // over-confidence

          event.type=Events.type.INFO;

          break;

        case "61": // low formation experience

          event.type=Events.type.INFO;

          break;

        case "62": // pull back to defende lead

          event.type=Events.type.INFO;

          break;

        case "63": // half time briefing - organization up (after over-confidence)

          event.type=Events.type.INFO;

          break;

        case "64": // half time briefing - organization up (?)

          event.type=Events.type.INFO;

          break;

        case "65": // low team experience - organization down

          event.type=Events.type.INFO;

          break;

        case "68": // pressing sucessful

          event.type=Events.type.INFO;

          break;

        case "70": // extra time start

          event.type=Events.type.INFO;

          break;

        case "71": // extra time over. draw. penalties 

          event.type=Events.type.INFO;

          break;

        case "72": // extra time over. one team win 

          event.type=Events.type.INFO;

          // subjectTeamId: wining team id

          break;

        case "90": // injury. buised. continues playing 

          // subjectPlayerId: buised player id

          // subjectTeamId: team id

          event.type=Events.type.BRUISED;

          break;

        case "91": // injury. buised. get off 

          // subjectPlayerId: injured id

          // subjectTeamId: team id

          // objectPlayerId: replacement player id

          event.type=Events.type.INJURY;

          break;

        case "92": // injury. heavy. get out 

          // subjectPlayerId: injured id

          // subjectTeamId: team id

          // objectPlayerId: replacement player id

          event.type=Events.type.INJURY;

          break;

        case "93": // injury. heavy. no substitution

          // subjectPlayerId: injured id

          // subjectTeamId: team id

          event.type=Events.type.INJURY;

          break;

        case "94": // bruised but keeps playing after medical aid.

          // subjectPlayerId: injured id

          // subjectTeamId: team id

          event.type=Events.type.BRUISED;

          break;

        case "95": // injury

          // subjectPlayerId: injured id

          // subjectTeamId: team id

          // objectPlayerId: replacement player id

          event.type=Events.type.INJURY;

          break;

        case "96": // injury. no substitution

          // subjectPlayerId: injured id

          // subjectTeamId: team id

          event.type=Events.type.INJURY;

          break;

        default:

          break;

      }

      break;

    case "1": // goal

    case "2": // missed goal

			if (event.key.A == 1) {

      	event.type=Events.type.GOAL;

      	Events.translate.addScorers(event);

			} else {

      	event.type=Events.type.MISS;

			}



      switch (event.key.BC) {

        case "05": // Unpredictable (create pass, other player finishes)

        	event.special =  new Event.special(strings.getString("event.special.unpredictable"));

        	break;

        case "06": // Unpredictable (intercept pass, finishes himself)

        	event.special =  new Event.special(strings.getString("event.special.unpredictable"));

        	break;

        case "07": // Long Shot (scores)

        	event.special =  new Event.special(strings.getString("event.special.long_shot"));

        	break;

        case "08": // Unpredictable (get the ball from opponent, finishes himself)

        	event.special =  new Event.special(strings.getString("event.special.unpredictable"));

        	break;

        case "09": // Unpredictable (give the ball to opponent, opponent finishes)

        	event.special =  new Event.special(strings.getString("event.special.unpredictable"));

        	break;

        	

        case "15": // Quick Attacker (scores himself)

        	event.special =  new Event.special(strings.getString("event.special.quick"));

        	break;

        case "16": // (passes to other attacker, other attacker finishes)

        	event.special =  new Event.special(strings.getString("event.special.quick"));

        	break;

        case "17": // Low Stamina (give the ball to opponent, opponent finishes)

        	event.special =  new Event.special(strings.getString("event.special.low_stamina"));

        	break;

        case "18": // Corner (scores)

        	event.special =  new Event.special(strings.getString("event.special.corner_kick"));

        	break;

        case "19": // Corner+Header (scores)

        	event.special =  new Event.special(strings.getString("event.special.corner_kick"));

        	break;

        	

        case "35": // Experienced Attacker (finishes himself)

        	event.special =  new Event.special(strings.getString("event.special.experience"));

        	break;

        case "36": // Low Experience (opponent scores)

        	event.special =  new Event.special(strings.getString("event.special.low_experience"));

        	break;

        case "37": // Cross Pass (create pass, other player finishes)

        	event.special =  new Event.special(strings.getString("event.special.winger"));

        	break;

        case "38": // Exceptional Passing (create pass, other player finishes)

        	event.special =  new Event.special(strings.getString("event.special.winger"));

        	break;

        case "39": // Technical Attacker vs Head Defender (finishes himself)

        	event.special =  new Event.special(strings.getString("event.special.technical"));

        	break;

	case "85": // Indirect Free Kick

	case "86":

		event.special =  new Event.special(strings.getString("event.special.indirect"));

		break;

      }

      

      /*  	

			switch (event.key.B) {

				case "0": // away leads, home redude

				case "1": // away leads, home evens

				case "2": // draw, home leads

				case "3": // home leads, home increase

				case "4": // counter-attack

				case "5": // home leads, away redude

				case "6": // home leads, away evens

				case "7": // draw, away leads

				case "8": // away leads, away increase

					break;

			}

			*/

			

			switch (event.key.C) {

				case "0" : // Free Kick

        	event.special =  new Event.special(strings.getString("event.side.free_kick"));

					break;				

				case "1" : // Center

        	event.special =  new Event.special(strings.getString("event.side.center"));

					break;				

				case "2" : // Left

        	event.special =  new Event.special(strings.getString("event.side.left"));

					break;				

				case "3" : // Right

        	event.special =  new Event.special(strings.getString("event.side.right"));

					break;				

				case "4" : // Penalty

        	event.special =  new Event.special(strings.getString("event.side.penalty"));

					break;

			}

			

			if (event.key.B == "4") { // Counter-Attack

	      	event.special.txt = (strings.getString("event.special.counter_attack")

	     				+ ", " + event.special.txt);

	    }

			break;

			



    case "3": // special tactics

      //event.isInfo = true;

      switch (event.key.BC) {

        case "31": // pressing

          // subjectTeamId: team id

          event.type=Events.type.INFO;

          match.getSideById(event.subjectTeamId).tactic = strings.getString("tactic.pressing");

          break;

        case "32": // counter-attack

          // subjectTeamId: team id

          event.type=Events.type.INFO;

          match.getSideById(event.subjectTeamId).tactic = strings.getString("tactic.counter_attack");

          break;

        case "33": // attack in the middle

          // subjectTeamId: team id

          event.type=Events.type.INFO;

          match.getSideById(event.subjectTeamId).tactic = strings.getString("tactic.aim");

          break;

        case "34": // attack on wings

          // subjectTeamId: team id

          event.type=Events.type.INFO;

          match.getSideById(event.subjectTeamId).tactic = strings.getString("tactic.aow");

          break;

        case "35": // play creatively

          // subjectTeamId: team id

          event.type=Events.type.INFO;

          match.getSideById(event.subjectTeamId).tactic = strings.getString("tactic.play_creative");

          break;

        default:

          break;

      };

      break;

    case "4": // nothing

      break;

    case "5": // cards & match over

      switch (event.key.BC) {

        case "01": // walkover - home team wins

          event.type=Events.type.INFO;

          break;

        case "02": // walkover - away team wins

          event.type=Events.type.INFO;

          break;

        case "10": // booking - first booking (aggressivity)

          // subjectPlayerId: player id

          // subjectTeamId: team id

          event.type=Events.type.YELLOW;

          break;

        case "11": // booking - first booking (honesty)

          // subjectPlayerId: player id

          // subjectTeamId: team id

          event.type=Events.type.YELLOW;

          break;

        case "12": // booking - second booking (aggressivity)

          // subjectPlayerId: player id

          // subjectTeamId: team id

          event.type=Events.type.YELLOW2;

          break;

        case "13": // booking - second booking (honesty)

          // subjectPlayerId: player id

          // subjectTeamId: team id

          event.type=Events.type.YELLOW2;

          break;

        case "14": // booking - sent off

          // subjectPlayerId: player id

          // subjectTeamId: team id

          event.type=Events.type.RED;

          break;

        case "99": // end of match

          event.type=Events.type.INFO;

          match.isFinish = true;

          break;

        default:

          break;

      };

      break;

    default:

      break;

  };

  //event.text = "(" + event.key.txt + ") " + event.text;



};



Events.translate.parseFormation = function(txt) {

  return Util.Parse("(\\d-\\d-\\d)", txt);

}



Events.translate.parseLineup = function(txt) {

  var lineup = new Array();

  try {

    var l = txt.split(": ")[1];

    var i;

    var zones=l.split(" - ");

    for(i=0; i<zones.length; i++) {

      lineup[lineup.length] = zones[i].split(", ");

    }

    i = lineup.length-1;

    var j = lineup[i].length-1;

    lineup[i][j] = lineup[i][j].substring(0, lineup[i][j].length-1);

  }

  catch (e) {

    // Argh, Magyar has some special translation of the lineup.

  }



  return lineup;

}



Events.translate.addScorers = function(event) {

  var team = event.match.getSideById(event.subjectTeamId);

  

  if (team.scorers == null)

     team.scorers = new Object();



  if (team.scorers[event.subjectPlayerId] == null ) {

    team.scorers[event.subjectPlayerId] =

      new Scorer(Events.translate.parseScorer(event.text, event.subjectPlayerId), " (");

  } else {

    team.scorers[event.subjectPlayerId].mins += ",";

  }

  team.scorers[event.subjectPlayerId].mins += event.minute;

}



Events.translate.parseScorer = function(txt, id) {

  return Util.Parse("ID=" + id + "\\\" title=\\\"[^\"]*\\\"&gt;(.*?)&lt;", txt);

}



function Scorer(name, mins) {

  this.name = name;

  this.mins = mins;

};





