function Team(id, name, shortName, youth) {

  this.id = id;

  this.name = name;

  this.shortName = shortName;

  this.youth = youth;

  this.addTeamToFriendsPopup=null;

};



var Teams = {

  myTeam: null,

  list: new Object()

}



Teams.update = function(newTeam) {

  var team = Teams.list["_"+newTeam.id+"_"+newTeam.youth]; 

  if (!team) {

    team=newTeam;

    Teams.list["_"+team.id+"_"+team.youth] = team;

    team.addTeamToFriendsPopup = LiveFox.DOM.createAddTeamToFriendsPopup(team);

    if (Friends.isFriend(team.id, team.youth, !Friends.STRICT)) {

      Friends.update(team.id, team.name);

    };

  } else {

    if (!team.name) team.name=newTeam.name;

    if (!team.shortName) team.shortName=newTeam.shortName;

  };

  return team;

};



Team.HTTPGetMyData = function () {

    var URL = HTTP.hattrickServer

                      + "/Common/teamDetails.asp?" + HTTP.type

                      + "&actionType=view";

  EventSystem.HTTPRequest(URL, Team.ParseMyData, "request.team_data");

};



Team.ParseMyData = function (xml) {

  var regUserString = "(<User>(?:.*?)</User>)";

  var regTeamString = "(<Team>(?:.*?)</Team>)";

  var regExp, found;

  var myTeam;



  try {

    regExp = new RegExp(regUserString);

    found = regExp.exec(xml);

    if (found) {

      Team.ParseMyUserData(found[1]);

    } else {

      alert("user data not found");

      return;

    }



    regExp = new RegExp("(<Team>.*</Team>)");

    found = regExp.exec(xml);



    regExp = new RegExp(regTeamString);

    found = regExp.exec(xml);

    if (found) {

      myTeam = Team.ParseTeamData(found[1]);

      Teams.myTeam = myTeam;

      Teams.update(myTeam);

    } else {

      alert("team data not found");

      return;

    }

  } catch(e) {

    alert("ParseMyData: " + e);

  }

  EventSystem.Declare(EventSystem.ev.MY_TEAM);



};



Team.ParseMyUserData = function (xml) {

  // nothing to do yet

};



Team.ParseTeamData = function (xml) {

  try {

    var id = Team.ParseTeamId(xml);

    var name = Team.ParseTeamName(xml);

    var shortName = Team.ParseShortTeamName(xml);

    var youth = Team.ParseYouth(xml);

    team = new Team(id, name, shortName, youth);



    //team.arena = Team.ParseArena(xml);

    //team.country = Team.ParseCountry(xml);

    team.league = Team.ParseLeague(xml);



    return team;

  } catch(e) {

    alert("ParseTeamData: " + e);

  }

  return null;

};



Team.ParseTeamId = function (xml) {

  return Util.Parse("<TeamID>(.*?)</TeamID>", xml);

};



Team.ParseTeamName = function (xml) {

  return Util.Parse("<TeamName>(.*?)</TeamName>", xml);

};



Team.ParseShortTeamName = function (xml) {

  return Util.Parse("<ShortTeamName>(.*?)</ShortTeamName>", xml);

};



Team.ParseYouth = function (xml) {

  //return Util.Parse("<IsYouth>(.*?)</IsYouth>", xml);

  return "False";

};



Team.ParseArena = function (xml) {

  var id, name;

  try {

    var xmlArena = Util.Parse("(<Arena>(?:.*?)</Arena>)", xml);

    id = Util.Parse("<ArenaID>(.*?)</ArenaID>", xmlArena);

    name = Util.Parse("<ArenaName>(.*?)</ArenaName>", xmlArena);

    var arena = new Arena(id, name);

    return arena;

  } catch(e) {

  }

  return null;

};



Team.ParseCountry = function (xml) {

  var id, name;

  try {

    var xmlCountry = Util.Parse("(<League>(?:.*?)</League>)", xml);

    id = Util.Parse("<LeagueID>(.*?)</LeagueID>", xmlCountry);

    name = Util.Parse("<LeagueName>(.*?)</LeagueName>", xmlCountry);

    var country = new Country(id, name);

    return country;

  } catch(e) {

  }

  return null;

};



Team.ParseLeague = function (xml) {

  var id, name, level;

  try {

    var xmlLeague = Util.Parse("(<LeagueLevelUnit(?:.*?)</LeagueLevelUnit>)", xml);

    id = Util.Parse("<LeagueLevelUnitID>(.*?)</LeagueLevelUnitID>", xmlLeague);

    name = Util.Parse("<LeagueLevelUnitName>(.*?)</LeagueLevelUnitName>", xmlLeague);

    level = Util.Parse("<LeagueLevel>(.*?)</LeagueLevel>", xmlLeague);

    var league = new League(id, name, level);

    return league;

  } catch(e) {

    alert("Team.ParseLeague:" + e);

  }

  return null;

};





